 /*
 //
 //		FischerRandom initial Board Configuration Program
 //
 //		Created by:		Brent Hansen
 //		Date:				17-Sep-1996
 */
 
#include <stdlib.h>
#include <stdio.h>
#include <time.h>


static char FirstRow[10] = {0};  /* Array of characters to hold results	*/

main()
{
int i, j, empty, rook_flag;
unsigned int seed;
int one_of_four = RAND_MAX / 4;
int one_of_five = RAND_MAX / 5;
int one_of_six = RAND_MAX / 6;

seed = (unsigned)time(0);
srand(seed);

/* 
   Position first Bishop - generate a random number from 0 to 3
   and put the Bishop on a1, c1, e1, or g1 corresponding to the
   number that is generated.
*/

i = rand();
i = i / one_of_four;
/* printf("first i = %d\n", i); */

FirstRow[i*2] = 'B';
	
/* 
   Position second Bishop - generate a random number from 0 to 3
   and put the Bishop on b1, d1, f1, or h1 corresponding to the
   number that is generated.
*/

i = rand();
i = i / one_of_four;
/* printf("second i = %d\n", i); */

FirstRow[(i*2) + 1] = 'B';
	
/* 
   Position Queen by generating a random number from 0 to 5 and
   put the Queen on the empty spot that corresponds to the number
   generated. If the number is 3, she goes into the fourth empty
   space, etc.
*/

i = rand();
i = i / one_of_six;
/* printf("third i = %d\n", i); */

empty = 0;
for(j = 0; j < 8; j++)
	{
	
	if( FirstRow[j] == 0)
			{
			if( empty == i )
				{
				FirstRow[j] = 'Q';
				break;
				}
			empty++;
	         }
	}
		         
/* 
   Position first Knight by generating a random number from 0 to 4 and
   put the Knight on the empty spot that corresponds to the number
   generated.
*/

i = rand();
i = i / one_of_five;
/* printf("fourth i = %d\n", i); */

empty = 0;
for(j = 0; j < 8; j++)
	{
	
	if( FirstRow[j] == 0)
			{
			if( empty == i )
				{
				FirstRow[j] = 'N';
				break;
				}
			empty++;
	         }
	}
	
/* 
   Position second Knight by generating a random number from 0 to 3 and
   put the Knight on the empty spot that corresponds to the number
   generated.
*/

i = rand();
i = i / one_of_four;
/* printf("fifth i = %d\n", i); */

empty = 0;
for(j = 0; j < 8; j++)
	{
	
	if( FirstRow[j] == 0)
			{
			if( empty == i )
				{
				FirstRow[j] = 'N';
				break;
				}
			empty++;
	         }
	}
	
/* 
   There are three slots empty at this point. Position a
   Rook first, then the King, and then the remaining Rook
   in the empty slots.
*/

rook_flag = 1;
for(j = 0; j < 8; j++)
	{
	if( FirstRow[j] == 0)
		{
		if( rook_flag )
			{
			FirstRow[j] = 'R';
			rook_flag = 0;
			}
		else
			{
			FirstRow[j] = 'K';
			rook_flag = 1;
			}
		}
	}

printf("\n  The First Row is:  %s\n", FirstRow);

return(0);
}